/*
 *    QOS (quality of service).
 *   Ethernet-  802.1p/802.1q
 *  3- ,   .
 * (http://www.rhyshaden.com/ethernet.htm#802.1p)
 *    Precedence    TOS  IP.
 * (http://www.rhyshaden.com/ipdgram.htm)
 *   8   .
 *        ,
 *   Precedence.
 */
#include <buf/buf-queue.h>

#define BUF_PRIO_NQ	8

typedef struct _buf_prio_queue_t {
	int count;
	int size;
	buf_queue_t queue [BUF_PRIO_NQ];
} buf_prio_queue_t;

struct _buf_t;

void buf_prio_queue_init (buf_prio_queue_t *q, struct _buf_t **buf, int bytes);
struct _buf_t *buf_prio_queue_get (buf_prio_queue_t *q);
int buf_prio_queue_put (buf_prio_queue_t *q, struct _buf_t *p, int prio);
struct _buf_t *buf_prio_queue_exchange (buf_prio_queue_t *q, struct _buf_t *p,
	int prio);
