/*
 * Definitions etc. for regexp(3) routines.
 */
typedef struct _regexp_t regexp_t;

/*
 * Determine the required size.
 * On failure, returns 0.
 */
unsigned short regexp_size (const char *pattern);

/*
 * Compile a regular expression into internal code.
 * Returns 1 on success, or 0 on failure.
 */
unsigned char regexp_compile (regexp_t *re, const char *pattern);

/*
 * Match a regular expression against a string.
 * Returns 1 on success, or 0 on failure.
 */
unsigned char regexp_execute (regexp_t *re, const char *str);

/*
 * Perform substitutions after a regexp match.
 * Returns 1 on success, or 0 on failure.
 */
unsigned char regexp_substitute (const regexp_t *re, const char *src, char *dst);
