/*
   Copyright (C) 1999 Marek Michalkiewicz <marekm@linux.org.pl>

   Permission to use, copy, modify, and distribute this software and
   its documentation for any purpose and without fee is hereby granted,
   without any conditions or restrictions.  This software is provided
   "as is" without express or implied warranty.
 */

#include <runtime/lib.h>

void *
memchr(const void *s, char c, mem_size_t n)
{
	if (n) {
		do {
			if (*((const char *) s)++ == c)
				/* return (void *) --s; */
				goto found;  /* ugly, but faster loop */
		} while (--n);
	}
	return 0;
found:
	return (void *)(((char *)s) - 1);
}
