/*
   Copyright (C) 1999 Marek Michalkiewicz <marekm@linux.org.pl>

   Permission to use, copy, modify, and distribute this software and
   its documentation for any purpose and without fee is hereby granted,
   without any conditions or restrictions.  This software is provided
   "as is" without express or implied warranty.
 */

#include <runtime/lib.h>

void *
memcpy(void *dest, const void *src, mem_size_t n)
{
	if (n) {
		register char *tmp = (char *) dest;
		do {
			*tmp++ = *((const char *) src)++;
		} while (--n);
	}
	return dest;
}
